/* -*- MaTX -*-
 *
 * tmd00027.h: TMD No. tmd00027 ץ(żαץ)
 *                              إåե
 *
 *  Originally written by KIYOTA Hiromitsu <1999/10/02>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00027.h,v 1.1 1999/10/03 09:10:46 kiyota Exp $
 */

#ifndef _TMD00027_H
#define _TMD00027_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00027_USER_H
#include TMD00027_USER_H
#endif /* TMD00027_USER_H */

#ifndef TMD00027_MM
#define TMD00027_MM "tmd00027.mm"
#endif /* !TMD00027_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00027(var) _tmd00027_ ## var
#else /* ! TMD_ANSI */
#define tmd00027(var) _tmd00027_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00027(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ(x)(u)(y)μο
//#define TMD00027_DIM_STATE (35+3)
#define TMD00027_DIM_STATE (Rows(tmd00027(A))+3)
#define TMD00027_DIM_INPUT 5
#define TMD00027_DIM_OUTPUT 7
#define TMD00027_DIM_ALL_IOS (TMD00027_DIM_INPUT+TMD00027_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00027(xx) [xx(1:TMD00027_DIM_STATE)]
#define chop_other_state_tmd00027(xx) [xx(TMD00027_DIM_STATE+1:)]
#define chop_input_tmd00027(uu) [uu(1:TMD00027_DIM_INPUT)]

// ǥ(ʪ)ѥ᡼
TMD_EXTERN Matrix tmd00027(G), tmd00027(delay);
TMD_EXTERN Matrix tmd00027(gnom), tmd00027(coef), tmd00027(delta_eps);
TMD_EXTERN Matrix tmd00027(u_max), tmd00027(u_min);
TMD_EXTERN Matrix tmd00027(du_lim);
TMD_EXTERN Matrix tmd00027(A), tmd00027(B), tmd00027(C), tmd00027(D);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00027_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00027_DISABLE_HALIST
TMD_EXTERN Integer tmd00027_flag;
#endif /* TMD00027_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00027_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00027_DIVIDED_COMPILE)
#include TMD00027_MM
#else /* !(!TMD_USER_MM && !TMD00027_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00027_DIVIDED_COMPILE) */
void init_tmd00027(/* linear_flag, params_flag, */ ...); // require TMD00027_MM;
Matrix diff_tmd00027(/* t, x, u */); // require TMD00027_MM;
Matrix output_tmd00027(/* t, x, u */); // require TMD00027_MM;
#endif /* !TMD_USER_MM && !TMD00027_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00027_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00027_H */
